<?php
/* 
 * Inits the admin dashboard side of things.
 * Main admin file which loads all settings panels and sets up admin menus. 
 */
if (!class_exists('GNA_Slack_Admin_Init')) {
	class GNA_Slack_Admin_Init {
		var $main_menu_page;
		//var $dashboard_menu;
		var $settings_menu;

		public function __construct() {
			//This class is only initialized if is_admin() is true
			$this->admin_includes();
			add_action('admin_menu', array(&$this, 'create_admin_menus'));

			if ( isset($_GET['page']) && (strpos($_GET['page'], GNA_SLACK_NOTIFICATION_MENU_SLUG_PREFIX ) !== false) ) {
				add_action('admin_print_scripts', array(&$this, 'admin_menu_page_scripts'));
				add_action('admin_print_styles', array(&$this, 'admin_menu_page_styles'));
			}
		}

		public function admin_menu_page_scripts() {
			wp_enqueue_script('jquery');
			wp_enqueue_script('postbox');
			wp_enqueue_script('dashboard');
			wp_enqueue_script('thickbox');

			wp_register_script('gna-sn-script', GNA_SLACK_NOTIFICATION_URL. '/assets/js/gna-slack-notification.js', array(), GNA_SLACK_NOTIFICATION_VERSION);
			wp_localize_script('gna-sn-script', 'gna', array(
				's_webhook' => __( 'Webhook', 'gna-slack-notification' ),
				's_webhook_url' => __( 'Webhook URL', 'gna-slack-notification' ),
				's_delete_btn' => __( 'Delete', 'gna-slack-notification' ),
				's_channel_name' => __( 'Channel', 'gna-slack-notification' ),
				's_bot_name' => __( 'Bot Name', 'gna-slack-notification' ),
				's_emoji_name' => __( 'Emoji', 'gna-slack-notification' ),
				's_events_notify' => __( 'Events to Notify', 'gna-slack-notification' ),
				'html_events_notify' => GNA_Slack::generate_event_notify_dropdown(),
				's_channel_notice' => __( 'Channel Notice', 'gna-slack-notification' ),
				'html_channel' => GNA_Slack::generate_yesno_dropdown('g_channel_notice[]'),
				's_activated' => __( 'Activated', 'gna-slack-notification' ),
				'html_activated' => GNA_Slack::generate_yesno_dropdown('g_activated[]'),
			));
			wp_enqueue_script('gna-sn-script');
		}

		function admin_menu_page_styles() {
			wp_enqueue_style('dashboard');
			wp_enqueue_style('thickbox');
			wp_enqueue_style('global');
			wp_enqueue_style('wp-admin');
			wp_enqueue_style('gna-slack-notification-admin-css', GNA_SLACK_NOTIFICATION_URL. '/assets/css/gna-slack-notification.css');
		}

		public function admin_includes() {
			include_once('gna-slack-notification-admin-menu.php');
		}

		public function create_admin_menus() {
			$this->main_menu_page = add_menu_page( __('GNA Slack', 'gna-slack-notification'), __('GNA Slack', 'gna-slack-notification'), 'manage_options', 'gna-sn-settings-menu', array(&$this, 'handle_settings_menu_rendering'), GNA_SLACK_NOTIFICATION_URL . '/assets/images/gna_20x20.png' );

			add_submenu_page('gna-sn-settings-menu', __('Settings', 'gna-slack-notification'),  __('Settings', 'gna-slack-notification'), 'manage_options', 'gna-sn-settings-menu', array(&$this, 'handle_settings_menu_rendering'));

			add_action( 'admin_init', array(&$this, 'register_gna_slack_notification_settings') );
		}

		public function register_gna_slack_notification_settings() {
			register_setting( 'gna-slack-notification-setting-group', 'g_slack_configs' );
		}

		public function handle_settings_menu_rendering() {
			include_once('gna-slack-notification-admin-settings-menu.php');
			$this->settings_menu = new GNA_Slack_Settings_Menu();
		}
	}
}
